'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.factory = exports.FULLFILLED_AND_TRUE = exports.FULLFILLED = undefined;

var _lexer = require('./lexer');

var _lexer2 = _interopRequireDefault(_lexer);

var _parser = require('./parser');

var _parser2 = _interopRequireDefault(_parser);

var _runtime = require('./runtime');

var _runtime2 = _interopRequireDefault(_runtime);

var _errObject = require('err-object');

var _errObject2 = _interopRequireDefault(_errObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const FULLFILLED = exports.FULLFILLED = promise => {
  return promise.then(() => true, () => false);
};

const FULLFILLED_AND_TRUE = exports.FULLFILLED_AND_TRUE = promise => {
  return promise.then(result => !!result, () => false);
};

const factory = exports.factory = (...args) => {
  const checker = args[0];
  if (typeof checker === 'function') {
    return (...args) => _factory(checker, true, ...args);
  }

  return _factory(FULLFILLED, true, ...args);
};

exports.default = (...args) => {
  const checker = args[0];
  if (typeof checker === 'function') {
    return (...args) => _factory(checker, false, ...args);
  }

  return _factory(FULLFILLED, false, ...args);
};

// Utilities
////////////////////////////////////////////////////////////////////

const _factory = (checker, useFactory, operators, ...items) => {
  if (useFactory && !items.every(isFunction)) {
    throw (0, _errObject2.default)({
      message: 'only accepts factory functions',
      name: 'NotFunctionError',
      code: 'NOT_FUNCTION'
    }, TypeError);
  }

  const lexer = new _lexer2.default(operators, items);
  const AST = new _parser2.default(lexer).parse();
  return new _runtime2.default(AST, checker, useFactory ? wrapPromiseFactory : wrapPromise).process();
};

const isFunction = subject => typeof subject === 'function';
const wrapPromise = subject => Promise.resolve(subject);
const wrapPromiseFactory = subject => Promise.resolve(subject());